'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _Dropdown = require('./Dropdown');

var _Dropdown2 = _interopRequireDefault(_Dropdown);

var _MenuItem = require('./MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _SplitToggle = require('./SplitToggle');

var _SplitToggle2 = _interopRequireDefault(_SplitToggle);

var _lodashCompatObjectOmit = require('lodash-compat/object/omit');

var _lodashCompatObjectOmit2 = _interopRequireDefault(_lodashCompatObjectOmit);

var _lodashCompatObjectPick = require('lodash-compat/object/pick');

var _lodashCompatObjectPick2 = _interopRequireDefault(_lodashCompatObjectPick);

var Select = _react2['default'].createClass({
  displayName: 'Select',

  getInitialState: function getInitialState() {
    return {
      selectOption: {
        value: this.props.value,
        text: ''
      },
      selectIndex: this.props.selectIndex || -1 // 选中的第几项 
    };
  },
  componentWillMount: function componentWillMount() {
    var _this = this;
    this.props.children.map(function (item, index) {
      if (_this.props.value && _this.props.value == item.props.value) {
        _this.setState({
          selectIndex: index,
          selectOption: {
            value: _this.props.value,
            text: item.props.children
          }
        });
      } else if (_this.props.selectIndex && _this.props.selectIndex == index) {
        _this.setState(_extends({}, _this.state, {
          selectOption: {
            value: item.props.value,
            text: item.props.children
          }
        }));
      }
    });
  },
  render: function render() {
    var _this2 = this;

    var _this = this;
    var _props = this.props;
    var bsSize = _props.bsSize;
    var bsStyle = _props.bsStyle;

    var props = _objectWithoutProperties(_props, ['bsSize', 'bsStyle']);

    var dropdownProps = _lodashCompatObjectPick2['default'](props, _Object$keys(_Dropdown2['default'].ControlledComponent.propTypes));
    var buttonProps = _lodashCompatObjectOmit2['default'](props, _Object$keys(_Dropdown2['default'].ControlledComponent.propTypes));

    return _react2['default'].createElement(
      _Dropdown2['default'],
      _extends({}, dropdownProps, { key: this.props.name, className: 'select-dropdown' }),
      _react2['default'].createElement(
        _Dropdown2['default'].Toggle,
        _extends({}, buttonProps, {
          className: 'select-text',
          disabled: false,
          noCaret: true,
          style: { width: this.props.width }
        }),
        this.state.selectOption.text
      ),
      _react2['default'].createElement(_Dropdown2['default'].Toggle, _extends({
        className: 'select-btn'
      }, buttonProps, {
        disabled: false
      })),
      _react2['default'].createElement('input', { type: 'hidden', value: this.state.selectOption.value, 'data-text': this.state.selectOption.text, ref: 'selectInput' }),
      _react2['default'].createElement(
        _Dropdown2['default'].Menu,
        { style: { width: this.props.width + 25, maxHeight: this.props.maxHeight, overflowY: 'auto' } },
        this.props.children.map(function (item, index) {
          return _react2['default'].createElement(
            _MenuItem2['default'],
            { eventKey: index, key: index, active: index == _this.state.selectIndex ? true : false, onClick: _this2.selectItem.bind(_this2, index, item) },
            item.props.children
          );
        })
      )
    );
  },
  selectItem: function selectItem(index, item, e) {
    e.stopPropagation();

    var selectOption = {
      value: item.props.value,
      text: item.props.children
    };

    this.setState(_extends({}, this.state, {
      selectIndex: index,
      selectOption: selectOption
    }));
    // 回调onSelect 事件
    this.props.onSelected(selectOption);
  }
});

Select.propTypes = {
  /**
   * 默认选中的项value值
   */
  value: _react2['default'].PropTypes.string,
  /**
   * 宽度
   */
  width: _react2['default'].PropTypes.number,
  /**
   * 默认选中项
   */
  selectIndex: _react2['default'].PropTypes.number,
  /**
   * onSelected 事件
   */
  onSelected: _react2['default'].PropTypes.func,
  /**
   * maxHeight 最大高度
   */
  maxHeight: _react2['default'].PropTypes.number
};

Select.defaultProps = {
  width: 200,
  maxHeight: 180
};
exports['default'] = Select;
module.exports = exports['default'];